/***********************************************************************************
* Filename 		$RCSfile: alg1_moves.c,v $
* Current CVS 		$Revision: 1.4 $
* Checked-in by 	$Author: yves $ 
*
* $Log: alg1_moves.c,v $
* Revision 1.4  2004/12/16 00:18:25  yves
* Standard CVS command tags added
* FEN notation inverted, now uppercase is white and lowercase is black
*
*
***********************************************************************************/

#include "alg1_moves.h"
#include "alg1_board.h"

// --------------------------------------------------------------------

extern struct st_alg1_board m1_board;
extern struct st_alg1_movelist m1_movelist;
extern char m1_aPieceValues[BOARDARRAY_SIZE];

extern int curply;

// --------------------------------------------------------------------

static int compare_score(const void *m1, const void *m2);

// --------------------------------------------------------------------

int order_moves(const int iMoves){
	
	int i;
	t_score fValue;
	
	posid cSourceField;
	posid cDestField;

	// todo: add killer statistics

	for (i=0; i<iMoves; i++) {
		
		fValue = -SCORE_ALMOST_WON;
		
		cSourceField = toupper(m1_board.m_fields[m1_movelist.m1_moves[i].ucFrom]);
		cDestField = toupper(m1_board.m_fields[m1_movelist.m1_moves[i].ucTo]);

		if (m1_movelist.m1_moves[i].bNonSilent)			fValue += 10.0;
		if (m1_movelist.m1_moves[i].bFlag)				fValue += 9.0;
		if ((cSourceField == PIECE_QUEEN) && (curply < 10))		fValue -= 5.0;
		
		fValue += m1_aPieceValues[cDestField] - m1_aPieceValues[cSourceField];
				
		m1_movelist.m1_moves[i].bValue = fValue;
	}
	
	qsort_moves();
	
	return 0;
}

// --------------------------------------------------------------------

void qsort_moves(void)
{
	qsort(&(m1_movelist.m1_moves[0]),m1_movelist.m1_count,sizeof(t_alg1_move),compare_score);
}

// --------------------------------------------------------------------

static int compare_score(const void *m1, const void *m2)
{
	const t_alg1_move * move1 = m1;
	const t_alg1_move * move2 = m2;
	
	if (move1->bValue > move2->bValue) return -1;
	if (move1->bValue < move2->bValue) return 1;
	return 0;
}

// --------------------------------------------------------------------
// eof