/***********************************************************************************
* Filename 		$RCSfile: alg1_moves.h,v $
* Current CVS 		$Revision: 1.8 $
* Checked-in by 	$Author: yves $ 
*
* $Log: alg1_moves.h,v $
* Revision 1.8  2005/03/28 22:35:08  yves
* Remove bitfields -  alleged bug but probably not a bug
*
* Revision 1.7  2004/12/17 23:38:00  yves
* add depth to move structure - used for audit right now
*
* Revision 1.6  2004/12/17 17:36:26  yves
* add typedefs
*
* Revision 1.5  2004/12/16 03:02:19  yves
* Change to bitfields
*
* Revision 1.4  2004/12/16 00:18:25  yves
* Standard CVS command tags added
* FEN notation inverted, now uppercase is white and lowercase is black
*
*
***********************************************************************************/

#if !defined(__ALG1_MOVES_H__)
#define __ALG1_MOVES_H__

#include "belofte.h"
#include "alg1_search.h"
#include "alg1_eval.h"

// --------------------------------------------------------------------

int order_moves(const int iMoves);
void qsort_moves(void);

// --------------------------------------------------------------------

struct st_alg1_move { 
	posid ucFrom;				// from position
	posid ucTo;					// to position
	t_promotion bFlag;			// is a promotion move, piece
	t_boolean bNonSilent;		// is a capture move
	t_depth iDepth;				// depth this move is searched at
	t_score bValue;				// evaluation of this move
} ;

// --------------------------------------------------------------------

typedef struct st_alg1_move		t_alg1_move;

// --------------------------------------------------------------------

struct st_alg1_movelist {
	t_alg1_move  m1_moves[MAX_MOVES_PER_POSITION];
	int m1_count;
} ;

// --------------------------------------------------------------------

typedef struct st_alg1_movelist	t_alg1_moves;

// --------------------------------------------------------------------

#endif
