/***********************************************************************************
* Filename 		$RCSfile: alg1_search.h,v $
* Current CVS 		$Revision: 1.12 $
* Checked-in by 	$Author: yves $ 
*
* $Log: alg1_search.h,v $
* Revision 1.12  2005/03/28 22:26:20  yves
* Add typedef for position
*
* Revision 1.11  2004/12/24 01:25:33  yves
* Opening book in binary mode implemented.
* Version 0.2.6
*
* Revision 1.9  2004/12/18 15:34:15  yves
* export printable move
*
* Revision 1.8  2004/12/18 10:48:23  yves
* Move boardmapper and applymove to board source
*
* Revision 1.7  2004/12/18 02:31:04  yves
* When double moves exist, make sure to write the correct move
*
* Revision 1.6  2004/12/17 17:36:42  yves
* move to board
*
* Revision 1.5  2004/12/16 00:18:24  yves
* Standard CVS command tags added
* FEN notation inverted, now uppercase is white and lowercase is black
*
*
***********************************************************************************/

#if !defined(__ALG1_SEARCH_H__)
#define __ALG1_SEARCH_H__

#include "belofte.h"
#include "board.h"

// --------------------------------------------------------------------

#define MAX_DEPTH_EXTENTION 2
#define NON_SILENT_EXTENTION 0.333
#define CAPTURE_MOVE_EXTENTION 0.666
#define SILENT_EXTENTION 1

// set low for debugging
#define ALLOWED_DEVIATION 0.001   
#define LIST_LENGTH 9

// --------------------------------------------------------------------

#define CAPTURE_COLOUR_WHITE COLOUR_WHITE
#define CAPTURE_COLOUR_BLACK COLOUR_BLACK

#define TO_WHITE(x)		((x))
#define TO_BLACK(x)		((x) + (LOWERCASEBIT))

// --------------------------------------------------------------------

void search_constructor(void);
void search_init(void);
int  search_root(t_depth iDepth, char *szMove, int iLenMove);
int  search_apply_move(const char *szMove);
void search_initboard(void);
void search_printablemove(const int iSelectedMove, char *szMove);

int	fill_movelist(const t_colour nColour, const t_boolean bQuieuscience, const enum tFillMoves bFill);
void normalize_movelist(void);

unsigned int isUnderAttack(const posid iKingPos, const t_boolean bEvaluateForWhite);
unsigned int isUnderMinorAttack(const posid iPiecePos, const t_piece cPiece, const t_boolean bEvaluateForWhite);
t_boolean isInCheck(const t_boolean lEvaluateForWhite);

// --------------------------------------------------------------------

#endif


