/***********************************************************************************
* Filename 		$RCSfile: board.h,v $
* Current CVS 		$Revision: 1.16 $
* Checked-in by 	$Author: yves $ 
*
* $Log: board.h,v $
* Revision 1.16  2004/12/24 01:25:34  yves
* Opening book in binary mode implemented.
* Version 0.2.6
*
* Revision 1.15  2004/12/21 00:43:10  yves
* opening book implemented
*
* Revision 1.12  2004/12/18 11:53:10  yves
* add ep move
*
* Revision 1.11  2004/12/17 23:38:38  yves
* sidetomove has to be a 2 bit bitfield
*
* Revision 1.10  2004/12/17 17:37:37  yves
* move from search
*
* Revision 1.9  2004/12/16 03:03:09  yves
* Change to bitfields
* Add SAN moves in history, will be used for opening book handling
*
* Revision 1.8  2004/12/16 00:18:25  yves
* Standard CVS command tags added
* FEN notation inverted, now uppercase is white and lowercase is black
*
*
***********************************************************************************/

#if !defined(__BOARD_H__)
#define __BOARD_H__

#include "belofte.h"

// --------------------------------------------------------------------

struct st_board 
	{
		t_field		m_fields[8][8];			// board representation
		t_flag		m_piecemoved[2][2];		// storage for rooks if moved (or both if king moved)
		t_ply		m_ply;					// ply number in the game
		t_ply		m_rule50;				// number since last pawn move or capture
		posid		m_epfield;				// where can an ep move take place, 0 if none?
		t_colour	m_sidetomove:2;			// colour of player to move
	} ;

typedef struct st_board t_board;

// structure containing membuffer with board and all moves and representations of each move played
// used for undo and 

struct st_history {
	char szSANMove[MAX_MOVE_LENGTH];
	char szIntMove[MAX_MOVE_LENGTH];
	char szFEN[MAX_FEN_LENGTH];
	t_board m_board;
} ;

// board layout is left bottum index = 0, right bottom = 7, left top = 56, right top = 63
// board element is n_field[column][row]

// --------------------------------------------------------------------

enum tPiece { FIELD_EMPTY = ' ' ,
	PIECE_BISHOP = 'B' ,
	PIECE_KING = 'K' , 
	PIECE_KNIGHT = 'N' , 
	PIECE_PAWN = 'P' ,
	PIECE_QUEEN = 'Q' , 
	PIECE_ROOK = 'R' ,
	BLACK_BISHOP = 'b' ,
	BLACK_KING = 'k' , 
	BLACK_KNIGHT = 'n' ,
	BLACK_PAWN = 'p' ,
	BLACK_QUEEN = 'q' , 
	BLACK_ROOK = 'r' ,
    FIELD_BORDER = '#' 
    };

typedef enum tPiece t_piece;

enum tPromotion { PROMOTION_NONE = 0, 
	PROMOTION_QUEEN = PIECE_QUEEN, PROMOTION_ROOK = PIECE_ROOK,
	PROMOTION_KNIGHT = PIECE_KNIGHT, PROMOTION_BISHOP = PIECE_BISHOP };

typedef enum tPromotion t_promotion;

#define LOWERCASEBIT	('a' - 'A')

// --------------------------------------------------------------------

int board_getmetadata(const char *szFlag);
int board_sanapplymove(char *szMove, char *szCoordMove);

// --------------------------------------------------------------------

#endif